<?php
/**

    Statiker
    Generates static files.
    
    @created 2011/05/09
    @author Oliver Leics
    @version 0.1
    
    @param friendly_urls
    @param site_url
    
    statiker.enable
    statiker.mime_types
    statiker.write_to_directory
    statiker.farm_url
    statiker.gzencode
    
 */

class Statiker {

    function __construct(modX &$modx, array $config = array()) {
        $this->modx =& $modx;
        
        $corePath = $modx->getOption('statiker.core_path',null,$modx->getOption('core_path').'components/statiker/');
        $assetsUrl = $modx->getOption('statiker.assets_url',null,$modx->getOption('assets_url').'components/statiker/');
        
        $this->config = array_merge(array(
            
            'corePath' => $corePath,
            'modelPath' => $corePath.'model/',
            'processorsPath' => $corePath.'processors/',
            'controllersPath' => $corePath.'controllers/',
            'includesPath' => $corePath.'includes/',

            'baseUrl' => $assetsUrl,
            'cssUrl' => $assetsUrl.'css/',
            'jsUrl' => $assetsUrl.'js/',
            'tplUrl' => $assetsUrl.'tpl/',
            
            'elementId' => 'statiker-panel-home-div',
            'auth' => $modx->site_id,
            
            'connectorUrl' => $assetsUrl.'connector.php',
            'enable' => $modx->getOption('statiker.enable'),
            'farm_url' => $modx->getOption('site_url', $modx->config).'assets/components/statiker/farm/',
            'mime_types' => $modx->getOption('statiker.mime_types'),
            'gzencode' => $modx->getOption('statiker.gzencode'),
            
            'log_file' => false, // dirname($this->modx->getOption('core_path')).'/statiker.log',
            'verbose' => true
            
        ), $config);
        
        $this->modx->addPackage('statiker',$this->config['modelPath']);
            // $manager = $this->modx->getManager();
            // $manager->createObjectContainer('statikerSite');
            // $manager->createObjectContainer('statikerFile');
        $this->modx->lexicon->load('statiker:default');
        
    }
    
    public function initialize() {
        $modx =& $this->modx;
        // 
        $modx->regClientStartupScript($this->config['jsUrl'].'mgr/statiker.js');
        $modx->regClientStartupHTMLBlock('<script type="text/javascript">
            Ext.onReady(function() {
                Statiker.config = '.$modx->toJSON($this->config).';
            });
        </script>');
        $modx->regClientStartupScript($this->config['jsUrl'].'mgr/widgets/files.grid.js');
        $modx->regClientStartupScript($this->config['jsUrl'].'mgr/widgets/statiker.grid.js');
        $modx->regClientStartupScript($this->config['jsUrl'].'mgr/widgets/home.panel.js');
        $modx->regClientStartupScript($this->config['jsUrl'].'mgr/sections/index.js');
        // 
        $output = '<div id="'.$this->config['elementId'].'"></div>';
        return $output;
    }
}
