<?php

/* validate name */
if(empty($scriptProperties['name'])) {
    $modx->error->addField('name', $modx->lexicon('statiker.site_err_ns_name'));
} else {
    $alreadyExists = $modx->getObject('statikerSite', array('name' => $scriptProperties['name']));
    if($alreadyExists) {
        $modx->error->addField('name', $modx->lexicon('statiker.site_err_ae'));
    }
}

/* validate write_to_directory */
if(empty($scriptProperties['write_to_directory'])) {
    $modx->error->addField('write_to_directory', $modx->lexicon('statiker.write_to_directory_err_ns'));
} else {
    $write_to_directory = realpath($scriptProperties['write_to_directory']);
    if(!$write_to_directory) {
        $modx->error->addField('write_to_directory', $modx->lexicon('statiker.write_to_directory_err_nf'));
    } else if(!is_dir($write_to_directory)) {
        $modx->error->addField('write_to_directory', $modx->lexicon('statiker.write_to_directory_err_nd'));
    } else if(!is_writable($write_to_directory)) {
        $modx->error->addField('write_to_directory', $modx->lexicon('statiker.write_to_directory_err_nw'));
    }
    $scriptProperties['write_to_directory'] = strtr($write_to_directory, '\\', '/').'/';
}

if ($modx->error->hasError()) { return $modx->error->failure(); }

$site = $modx->newObject('statikerSite');
$site->fromArray($scriptProperties);

if($site->save()==false) {
    return $modx->error->failure($modx->lexicon('statiker.site_err_save'));
}

return $modx->error->success('',$site);