<?php
/*
 * MODx Revolution
 *
 * Copyright 2006-2010 by the MODx Team.
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */
$mtime= microtime();
$mtime= explode(" ", $mtime);
$mtime= $mtime[1] + $mtime[0];
$tstart= $mtime;

error_reporting(E_ALL & ~E_NOTICE);

/**
 * @deprecated 2.0.0
 * For backward compatibility with MODx 0.9.x
 */
define("IN_PARSER_MODE", "true");
/**
 * @deprecated 2.0.0
 * For backward compatibility with MODx 0.9.x
 */
define("IN_MANAGER_MODE", false);

/* define this as true in another entry file, then include this file to simply access the API
 * without executing the MODx request handler */
if (!defined('MODX_API_MODE')) {
    define('MODX_API_MODE', false);
}

/* this can be used to disable caching in MODx absolutely */
$modx_cache_disabled= false;

/* include custom core config and define core path */
require_once dirname(dirname(dirname(dirname(dirname(__FILE__))))).'/config.core.php';
if (!defined('MODX_CORE_PATH')) define('MODX_CORE_PATH', dirname(__FILE__) . '/core/');

/* include the modX class */
if (!@include_once (MODX_CORE_PATH . "model/modx/modx.class.php")) {
    $errorMessage = 'Site temporarily unavailable';
    @include(MODX_CORE_PATH . 'error/unavailable.include.php');
    header('HTTP/1.1 503 Service Unavailable');
    echo "<html><title>Error 503: Site temporarily unavailable</title><body><h1>Error 503</h1><p>{$errorMessage}</p></body></html>";
    exit();
}

/* start output buffering */
ob_start();

/* Create an instance of the modX class */
if (empty($options) || !is_array($options)) $options = array();
$modx= new modX('', $options);
if (!is_object($modx) || !($modx instanceof modX)) {
    @ob_end_flush();
    $errorMessage = '<a href="setup/">MODx not installed. Install now?</a>';
    @include(MODX_CORE_PATH . 'error/unavailable.include.php');
    header('HTTP/1.1 503 Service Unavailable');
    echo "<html><title>Error 503: Site temporarily unavailable</title><body><h1>Error 503</h1><p>{$errorMessage}</p></body></html>";
    exit();
}

/* Set the actual start time */
$modx->startTime= $tstart;

/* Set additional logging options including level and target: */
$modx->setLogLevel(modX::LOG_LEVEL_ERROR);
$modx->setLogTarget('FILE');

/* Set debugging mode (i.e. error_reporting): */
$modx->setDebug(E_ALL & ~E_NOTICE);

/* test security token */
$token = @$_REQUEST['HTTP_MODAUTH']?$_REQUEST['HTTP_MODAUTH']:$_SERVER['HTTP_MODAUTH'];
if($token!=$modx->site_id) {
    header('HTTP/1.0 401 Access denied');
    header('Status: 401 Access denied');
    exit();
}
unset($token);

/* Initialize the default 'web' context */
$modx->initialize(isset($_REQUEST['ctx'])?$_REQUEST['ctx']:'web');

/* execute the request handler */
if (!MODX_API_MODE) {
    $modx->handleRequest();
}